keep the PID file locked for the lifetime of the process
[qemu.git] / Makefile
1 # Makefile for QEMU.
2
3 # Always point to the root of the build tree (needs GNU make).
4 BUILD_DIR=$(CURDIR)
5
6 GENERATED_HEADERS = config-host.h trace.h qemu-options.def
7 ifeq ($(TRACE_BACKEND),dtrace)
8 GENERATED_HEADERS += trace-dtrace.h
9 endif
10 GENERATED_HEADERS += qmp-commands.h qapi-types.h qapi-visit.h
11 GENERATED_SOURCES += qmp-marshal.c qapi-types.c qapi-visit.c
12
13 ifneq ($(wildcard config-host.mak),)
14 # Put the all: rule here so that config-host.mak can contain dependencies.
15 all: build-all
16 include config-host.mak
17 include $(SRC_PATH)/rules.mak
18 config-host.mak: $(SRC_PATH)/configure
19 @echo $@ is out-of-date, running configure
20 @sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
21 else
22 config-host.mak:
23 @echo "Please call configure before running make!"
24 @exit 1
25 endif
26
27 # Don't try to regenerate Makefile or configure
28 # We don't generate any of them
29 Makefile: ;
30 configure: ;
31
32 .PHONY: all clean cscope distclean dvi html info install install-doc \
33 pdf recurse-all speed tar tarbin test build-all
34
35 $(call set-vpath, $(SRC_PATH):$(SRC_PATH)/hw)
36
37 LIBS+=-lz $(LIBS_TOOLS)
38
39 ifdef BUILD_DOCS
40 DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8 QMP/qmp-commands.txt
41 DOCS+=fsdev/virtfs-proxy-helper.1
42 else
43 DOCS=
44 endif
45
46 SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory) BUILD_DIR=$(BUILD_DIR)
47 SUBDIR_DEVICES_MAK=$(patsubst %, %/config-devices.mak, $(TARGET_DIRS))
48 SUBDIR_DEVICES_MAK_DEP=$(patsubst %, %/config-devices.mak.d, $(TARGET_DIRS))
49
50 config-all-devices.mak: $(SUBDIR_DEVICES_MAK)
51 $(call quiet-command,cat $(SUBDIR_DEVICES_MAK) | grep =y | sort -u > $@," GEN $@")
52
53 -include $(SUBDIR_DEVICES_MAK_DEP)
54
55 %/config-devices.mak: default-configs/%.mak
56 $(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/make_device_config.sh $@ $<, " GEN $@")
57 @if test -f $@; then \
58 if cmp -s $@.old $@; then \
59 mv $@.tmp $@; \
60 cp -p $@ $@.old; \
61 else \
62 if test -f $@.old; then \
63 echo "WARNING: $@ (user modified) out of date.";\
64 else \
65 echo "WARNING: $@ out of date.";\
66 fi; \
67 echo "Run \"make defconfig\" to regenerate."; \
68 rm $@.tmp; \
69 fi; \
70 else \
71 mv $@.tmp $@; \
72 cp -p $@ $@.old; \
73 fi
74
75 defconfig:
76 rm -f config-all-devices.mak $(SUBDIR_DEVICES_MAK)
77
78 -include config-all-devices.mak
79
80 build-all: $(DOCS) $(TOOLS) recurse-all
81
82 config-host.h: config-host.h-timestamp
83 config-host.h-timestamp: config-host.mak
84 qemu-options.def: $(SRC_PATH)/qemu-options.hx
85 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@," GEN $@")
86
87 SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))
88
89 subdir-%: $(GENERATED_HEADERS)
90 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $* V="$(V)" TARGET_DIR="$*/" all,)
91
92 ifneq ($(wildcard config-host.mak),)
93 include $(SRC_PATH)/Makefile.objs
94 endif
95
96 $(common-obj-y): $(GENERATED_HEADERS)
97 subdir-libcacard: $(oslib-obj-y) $(trace-obj-y) qemu-timer-common.o
98
99 $(filter %-softmmu,$(SUBDIR_RULES)): $(trace-obj-y) $(common-obj-y) subdir-libdis
100
101 $(filter %-user,$(SUBDIR_RULES)): $(GENERATED_HEADERS) $(trace-obj-y) subdir-libdis-user subdir-libuser
102
103 ROMSUBDIR_RULES=$(patsubst %,romsubdir-%, $(ROMS))
104 romsubdir-%:
105 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C pc-bios/$* V="$(V)" TARGET_DIR="$*/",)
106
107 ALL_SUBDIRS=$(TARGET_DIRS) $(patsubst %,pc-bios/%, $(ROMS))
108
109 recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)
110
111 audio/audio.o audio/fmodaudio.o: QEMU_CFLAGS += $(FMOD_CFLAGS)
112
113 QEMU_CFLAGS+=$(CURL_CFLAGS)
114
115 QEMU_CFLAGS+=$(GLIB_CFLAGS)
116
117 QEMU_CFLAGS += -I$(SRC_PATH)/include
118
119 ui/cocoa.o: ui/cocoa.m
120
121 ui/sdl.o audio/sdlaudio.o ui/sdl_zoom.o baum.o: QEMU_CFLAGS += $(SDL_CFLAGS)
122
123 ui/vnc.o: QEMU_CFLAGS += $(VNC_TLS_CFLAGS)
124
125 bt-host.o: QEMU_CFLAGS += $(BLUEZ_CFLAGS)
126
127 version.o: $(SRC_PATH)/version.rc config-host.h
128 $(call quiet-command,$(WINDRES) -I. -o $@ $<," RC $(TARGET_DIR)$@")
129
130 version-obj-$(CONFIG_WIN32) += version.o
131 ######################################################################
132 # Support building shared library libcacard
133
134 .PHONY: libcacard.la install-libcacard
135 ifeq ($(LIBTOOL),)
136 libcacard.la:
137 @echo "libtool is missing, please install and rerun configure"; exit 1
138
139 install-libcacard:
140 @echo "libtool is missing, please install and rerun configure"; exit 1
141 else
142 libcacard.la: $(GENERATED_HEADERS) $(oslib-obj-y) qemu-timer-common.o $(addsuffix .lo, $(basename $(trace-obj-y)))
143 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" libcacard.la,)
144
145 install-libcacard: libcacard.la
146 $(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C libcacard V="$(V)" TARGET_DIR="$*/" install-libcacard,)
147 endif
148 ######################################################################
149
150 qemu-img.o: qemu-img-cmds.h
151 qemu-img.o qemu-tool.o qemu-nbd.o qemu-io.o cmd.o qemu-ga.o: $(GENERATED_HEADERS)
152
153 tools-obj-y = $(oslib-obj-y) $(trace-obj-y) qemu-tool.o qemu-timer.o \
154 qemu-timer-common.o main-loop.o notify.o iohandler.o cutils.o async.o
155 tools-obj-$(CONFIG_POSIX) += compatfd.o
156
157 qemu-img$(EXESUF): qemu-img.o $(tools-obj-y) $(block-obj-y)
158 qemu-nbd$(EXESUF): qemu-nbd.o $(tools-obj-y) $(block-obj-y)
159 qemu-io$(EXESUF): qemu-io.o cmd.o $(tools-obj-y) $(block-obj-y)
160
161 fsdev/virtfs-proxy-helper$(EXESUF): fsdev/virtfs-proxy-helper.o fsdev/virtio-9p-marshal.o oslib-posix.o $(trace-obj-y)
162 fsdev/virtfs-proxy-helper$(EXESUF): LIBS += -lcap
163
164 qemu-img-cmds.h: $(SRC_PATH)/qemu-img-cmds.hx
165 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@," GEN $@")
166
167 $(qapi-obj-y): $(GENERATED_HEADERS)
168 qapi-dir := $(BUILD_DIR)/qapi-generated
169 qemu-ga$(EXESUF): LIBS = $(LIBS_QGA)
170
171 gen-out-type = $(subst .,-,$(suffix $@))
172
173 ifneq ($(wildcard config-host.mak),)
174 include $(SRC_PATH)/tests/Makefile
175 endif
176
177 $(qapi-dir)/qga-qapi-types.c $(qapi-dir)/qga-qapi-types.h :\
178 $(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-types.py
179 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, " GEN $@")
180 $(qapi-dir)/qga-qapi-visit.c $(qapi-dir)/qga-qapi-visit.h :\
181 $(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-visit.py
182 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, " GEN $@")
183 $(qapi-dir)/qga-qmp-commands.h $(qapi-dir)/qga-qmp-marshal.c :\
184 $(SRC_PATH)/qapi-schema-guest.json $(SRC_PATH)/scripts/qapi-commands.py
185 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o "$(qapi-dir)" -p "qga-" < $<, " GEN $@")
186
187 qapi-types.c qapi-types.h :\
188 $(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-types.py
189 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o "." < $<, " GEN $@")
190 qapi-visit.c qapi-visit.h :\
191 $(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-visit.py
192 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o "." < $<, " GEN $@")
193 qmp-commands.h qmp-marshal.c :\
194 $(SRC_PATH)/qapi-schema.json $(SRC_PATH)/scripts/qapi-commands.py
195 $(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -m -o "." < $<, " GEN $@")
196
197 QGALIB_OBJ=$(addprefix $(qapi-dir)/, qga-qapi-types.o qga-qapi-visit.o qga-qmp-marshal.o)
198 QGALIB_GEN=$(addprefix $(qapi-dir)/, qga-qapi-types.h qga-qapi-visit.h qga-qmp-commands.h)
199 $(QGALIB_OBJ): $(QGALIB_GEN) $(GENERATED_HEADERS)
200 $(qga-obj-y) qemu-ga.o: $(QGALIB_GEN) $(GENERATED_HEADERS)
201
202 qemu-ga$(EXESUF): qemu-ga.o $(qga-obj-y) $(qapi-obj-y) $(tools-obj-y) $(qobject-obj-y) $(version-obj-y) $(QGALIB_OBJ)
203
204 QEMULIBS=libhw32 libhw64 libuser libdis libdis-user
205
206 clean:
207 # avoid old build problems by removing potentially incorrect old files
208 rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
209 rm -f qemu-options.def
210 rm -f *.o *.d *.a *.lo $(TOOLS) qemu-ga TAGS cscope.* *.pod *~ */*~
211 rm -Rf .libs
212 rm -f slirp/*.o slirp/*.d audio/*.o audio/*.d block/*.o block/*.d net/*.o net/*.d fsdev/*.o fsdev/*.d ui/*.o ui/*.d qapi/*.o qapi/*.d qga/*.o qga/*.d
213 rm -f qemu-img-cmds.h
214 rm -f trace/*.o trace/*.d
215 rm -f trace.c trace.h trace.c-timestamp trace.h-timestamp
216 rm -f trace-dtrace.dtrace trace-dtrace.dtrace-timestamp
217 rm -f trace-dtrace.h trace-dtrace.h-timestamp
218 rm -f $(GENERATED_HEADERS)
219 rm -f $(GENERATED_SOURCES)
220 rm -rf $(qapi-dir)
221 $(MAKE) -C tests/tcg clean
222 for d in $(ALL_SUBDIRS) $(QEMULIBS) libcacard; do \
223 if test -d $$d; then $(MAKE) -C $$d $@ || exit 1; fi; \
224 rm -f $$d/qemu-options.def; \
225 done
226
227 distclean: clean
228 rm -f config-host.mak config-host.h* config-host.ld $(DOCS) qemu-options.texi qemu-img-cmds.texi qemu-monitor.texi
229 rm -f config-all-devices.mak
230 rm -f roms/seabios/config.mak roms/vgabios/config.mak
231 rm -f qemu-doc.info qemu-doc.aux qemu-doc.cp qemu-doc.cps qemu-doc.dvi
232 rm -f qemu-doc.fn qemu-doc.fns qemu-doc.info qemu-doc.ky qemu-doc.kys
233 rm -f qemu-doc.log qemu-doc.pdf qemu-doc.pg qemu-doc.toc qemu-doc.tp
234 rm -f qemu-doc.vr
235 rm -f config.log
236 rm -f linux-headers/asm
237 rm -f qemu-tech.info qemu-tech.aux qemu-tech.cp qemu-tech.dvi qemu-tech.fn qemu-tech.info qemu-tech.ky qemu-tech.log qemu-tech.pdf qemu-tech.pg qemu-tech.toc qemu-tech.tp qemu-tech.vr
238 for d in $(TARGET_DIRS) $(QEMULIBS); do \
239 rm -rf $$d || exit 1 ; \
240 done
241
242 KEYMAPS=da en-gb et fr fr-ch is lt modifiers no pt-br sv \
243 ar de en-us fi fr-be hr it lv nl pl ru th \
244 common de-ch es fo fr-ca hu ja mk nl-be pt sl tr
245
246 ifdef INSTALL_BLOBS
247 BLOBS=bios.bin sgabios.bin vgabios.bin vgabios-cirrus.bin \
248 vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin \
249 ppc_rom.bin openbios-sparc32 openbios-sparc64 openbios-ppc \
250 pxe-e1000.rom pxe-eepro100.rom pxe-ne2k_pci.rom \
251 pxe-pcnet.rom pxe-rtl8139.rom pxe-virtio.rom \
252 bamboo.dtb petalogix-s3adsp1800.dtb petalogix-ml605.dtb \
253 mpc8544ds.dtb \
254 multiboot.bin linuxboot.bin \
255 s390-zipl.rom \
256 spapr-rtas.bin slof.bin \
257 palcode-clipper
258 else
259 BLOBS=
260 endif
261
262 install-doc: $(DOCS)
263 $(INSTALL_DIR) "$(DESTDIR)$(docdir)"
264 $(INSTALL_DATA) qemu-doc.html qemu-tech.html "$(DESTDIR)$(docdir)"
265 ifdef CONFIG_POSIX
266 $(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
267 $(INSTALL_DATA) qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
268 $(INSTALL_DIR) "$(DESTDIR)$(mandir)/man8"
269 $(INSTALL_DATA) qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
270 endif
271 ifdef CONFIG_VIRTFS
272 $(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
273 $(INSTALL_DATA) fsdev/virtfs-proxy-helper.1 "$(DESTDIR)$(mandir)/man1"
274 endif
275 install-sysconfig:
276 $(INSTALL_DIR) "$(DESTDIR)$(sysconfdir)/qemu"
277 $(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/target-x86_64.conf "$(DESTDIR)$(sysconfdir)/qemu"
278
279 install: all $(if $(BUILD_DOCS),install-doc) install-sysconfig
280 $(INSTALL_DIR) "$(DESTDIR)$(bindir)"
281 ifneq ($(TOOLS),)
282 $(INSTALL_PROG) $(STRIP_OPT) $(TOOLS) "$(DESTDIR)$(bindir)"
283 endif
284 ifneq ($(BLOBS),)
285 $(INSTALL_DIR) "$(DESTDIR)$(datadir)"
286 set -e; for x in $(BLOBS); do \
287 $(INSTALL_DATA) $(SRC_PATH)/pc-bios/$$x "$(DESTDIR)$(datadir)"; \
288 done
289 endif
290 $(INSTALL_DIR) "$(DESTDIR)$(datadir)/keymaps"
291 set -e; for x in $(KEYMAPS); do \
292 $(INSTALL_DATA) $(SRC_PATH)/pc-bios/keymaps/$$x "$(DESTDIR)$(datadir)/keymaps"; \
293 done
294 for d in $(TARGET_DIRS); do \
295 $(MAKE) -C $$d $@ || exit 1 ; \
296 done
297
298 # various test targets
299 test speed: all
300 $(MAKE) -C tests/tcg $@
301
302 .PHONY: TAGS
303 TAGS:
304 find "$(SRC_PATH)" -name '*.[hc]' -print0 | xargs -0 etags
305
306 cscope:
307 rm -f ./cscope.*
308 find "$(SRC_PATH)" -name "*.[chsS]" -print | sed 's,^\./,,' > ./cscope.files
309 cscope -b
310
311 # documentation
312 MAKEINFO=makeinfo
313 MAKEINFOFLAGS=--no-headers --no-split --number-sections
314 TEXIFLAG=$(if $(V),,--quiet)
315 %.dvi: %.texi
316 $(call quiet-command,texi2dvi $(TEXIFLAG) -I . $<," GEN $@")
317
318 %.html: %.texi
319 $(call quiet-command,$(MAKEINFO) $(MAKEINFOFLAGS) --html $< -o $@, \
320 " GEN $@")
321
322 %.info: %.texi
323 $(call quiet-command,$(MAKEINFO) $< -o $@," GEN $@")
324
325 %.pdf: %.texi
326 $(call quiet-command,texi2pdf $(TEXIFLAG) -I . $<," GEN $@")
327
328 qemu-options.texi: $(SRC_PATH)/qemu-options.hx
329 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@," GEN $@")
330
331 qemu-monitor.texi: $(SRC_PATH)/hmp-commands.hx
332 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@," GEN $@")
333
334 QMP/qmp-commands.txt: $(SRC_PATH)/qmp-commands.hx
335 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -q < $< > $@," GEN $@")
336
337 qemu-img-cmds.texi: $(SRC_PATH)/qemu-img-cmds.hx
338 $(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@," GEN $@")
339
340 qemu.1: qemu-doc.texi qemu-options.texi qemu-monitor.texi
341 $(call quiet-command, \
342 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu.pod && \
343 pod2man --section=1 --center=" " --release=" " qemu.pod > $@, \
344 " GEN $@")
345
346 qemu-img.1: qemu-img.texi qemu-img-cmds.texi
347 $(call quiet-command, \
348 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu-img.pod && \
349 pod2man --section=1 --center=" " --release=" " qemu-img.pod > $@, \
350 " GEN $@")
351
352 fsdev/virtfs-proxy-helper.1: fsdev/virtfs-proxy-helper.texi
353 $(call quiet-command, \
354 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< fsdev/virtfs-proxy-helper.pod && \
355 pod2man --section=1 --center=" " --release=" " fsdev/virtfs-proxy-helper.pod > $@, \
356 " GEN $@")
357
358 qemu-nbd.8: qemu-nbd.texi
359 $(call quiet-command, \
360 perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu-nbd.pod && \
361 pod2man --section=8 --center=" " --release=" " qemu-nbd.pod > $@, \
362 " GEN $@")
363
364 dvi: qemu-doc.dvi qemu-tech.dvi
365 html: qemu-doc.html qemu-tech.html
366 info: qemu-doc.info qemu-tech.info
367 pdf: qemu-doc.pdf qemu-tech.pdf
368
369 qemu-doc.dvi qemu-doc.html qemu-doc.info qemu-doc.pdf: \
370 qemu-img.texi qemu-nbd.texi qemu-options.texi \
371 qemu-monitor.texi qemu-img-cmds.texi
372
373 VERSION ?= $(shell cat VERSION)
374 FILE = qemu-$(VERSION)
375
376 # tar release (use 'make -k tar' on a checkouted tree)
377 tar:
378 rm -rf /tmp/$(FILE)
379 cp -r . /tmp/$(FILE)
380 cd /tmp && tar zcvf ~/$(FILE).tar.gz $(FILE) --exclude CVS --exclude .git --exclude .svn
381 rm -rf /tmp/$(FILE)
382
383 # Include automatically generated dependency files
384 -include $(wildcard *.d audio/*.d slirp/*.d block/*.d net/*.d ui/*.d qapi/*.d qga/*.d)